#!/usr/bin/env python3

from typing import *
from math import inf 

# Example type annotations using the generic type List:
cities: List[str] = ["Stuttgart", "Paris", "Beijing"]

# TODO Annotate all variables and functions (arguments and return value) with the most specific type (e.g., not Any).

points = {
    "Vasili": 30.5,
    "Beatrice": 60.0,
    "Karim": 96.0,
    "Daniel": 0.0,
}

names = set()
names.add("John")
for name in points.keys():
    names.add(name)

name_longest = ''

for name in names:
    point = points.get(name)
    print(f'{name} has {point} points.')
    if len(name) > len(name_longest):
        name_longest = name

print('Longest name:', name_longest)

def average(values):
    if not values:
        return None
    sum: float = 0
    for i in values:
        sum += i
    return sum / len(values)

points_avg = average(list(points.values()))
print('Average points:', points_avg)

points_best = -inf
student_best = None
for name, point in points.items():
    if point > points_best:
        points_best = point
        student_best = (name, point)
print('Best student:', student_best)
