package types;

// A simple visitor interface over expressions.
// Check, e.g., the Gang-of-Four book or Wikipedia for an introduction of the visitor pattern.
// Can return a value of type T or throw an exception of type E.
public interface ExpressionVisitor<T, E extends Exception> {
    T visit(Expression.True e) throws E;
    T visit(Expression.False e) throws E;
    T visit(Expression.Int e) throws E;
    T visit(Expression.Neg e) throws E;
    T visit(Expression.Add e) throws E;
    T visit(Expression.Or e) throws E;
    T visit(Expression.Equals e) throws E;
    T visit(Expression.IfThenElse e) throws E;
}
